<?php
/**
 * Class which returns the class map definition
 * @package
 */
class ClassMap
{
    /**
     * Returns the mapping between the WSDL Structs and generated Structs' classes
     * This array is sent to the \SoapClient when calling the WS
     * @return string[]
     */
    final public static function get()
    {
        return array(
            'Policy' => '\\StructType\\Policy',
            'beneficiaries' => '\\StructType\\Beneficiaries',
            'ProductInfo' => '\\StructType\\ProductInfo',
            'InsCompInfo' => '\\StructType\\InsCompInfo',
            'SubjectInfo' => '\\StructType\\SubjectInfo',
            'PhysicalSubject' => '\\StructType\\PhysicalSubject',
            'DocumentInfo' => '\\StructType\\DocumentInfo',
            'DocumentList' => '\\StructType\\DocumentList',
            'AddressInfo' => '\\StructType\\AddressInfo',
            'BankDetails' => '\\StructType\\BankDetails',
            'PhysicalIdentificationDataInfo' => '\\StructType\\PhysicalIdentificationDataInfo',
            'RelatedPdlInfo' => '\\StructType\\RelatedPdlInfo',
            'DirectoryElemStrInfo' => '\\StructType\\DirectoryElemStrInfo',
            'TypePdlInfo' => '\\StructType\\TypePdlInfo',
            'JustificationRiskInfo' => '\\StructType\\JustificationRiskInfo',
            'FinancInformation' => '\\StructType\\FinancInformation',
            'BusinessReputationInfo' => '\\StructType\\BusinessReputationInfo',
            'JustificationNotIdentBenefInfo' => '\\StructType\\JustificationNotIdentBenefInfo',
            'VerificationBenefiziarInfo' => '\\StructType\\VerificationBenefiziarInfo',
            'JustificationNotIdentVigodInfo' => '\\StructType\\JustificationNotIdentVigodInfo',
            'IdentifBeneficiarListInfo' => '\\StructType\\IdentifBeneficiarListInfo',
            'IdentifBeneficiarInfo' => '\\StructType\\IdentifBeneficiarInfo',
            'PredstavitelListInfo' => '\\StructType\\PredstavitelListInfo',
            'IdentificRepresentativeInfo' => '\\StructType\\IdentificRepresentativeInfo',
            'BusinessLicenseList' => '\\StructType\\BusinessLicenseList',
            'BusinessLicense' => '\\StructType\\BusinessLicense',
            'SourcesOfIncome' => '\\StructType\\SourcesOfIncome',
            'JuridicalSubject' => '\\StructType\\JuridicalSubject',
            'ContactPersontList' => '\\StructType\\ContactPersontList',
            'ContactPerson' => '\\StructType\\ContactPerson',
            'SubjectListInfo' => '\\StructType\\SubjectListInfo',
            'ConstitutorListInfo' => '\\StructType\\ConstitutorListInfo',
            'UchreditelInfo' => '\\StructType\\UchreditelInfo',
            'JuridicalIdentificationDataInfo' => '\\StructType\\JuridicalIdentificationDataInfo',
            'ManagementBodyStructInfo' => '\\StructType\\ManagementBodyStructInfo',
            'IndivExecutBodyNameInfo' => '\\StructType\\IndivExecutBodyNameInfo',
            'CollegExecutBodyNameInfo' => '\\StructType\\CollegExecutBodyNameInfo',
            'ParametrList' => '\\StructType\\ParametrList',
            'ParametrInfo' => '\\StructType\\ParametrInfo',
            'InsuranceObjectList' => '\\StructType\\InsuranceObjectList',
            'InsuranceObject' => '\\StructType\\InsuranceObject',
            'RiskInfoList' => '\\StructType\\RiskInfoList',
            'RiskInfo' => '\\StructType\\RiskInfo',
            'KoeffInfoList' => '\\StructType\\KoeffInfoList',
            'KoeffInfo' => '\\StructType\\KoeffInfo',
            'RepresentativeInfo' => '\\StructType\\RepresentativeInfo',
            'CurrencyExchList' => '\\StructType\\CurrencyExchList',
            'CurrencyExch' => '\\StructType\\CurrencyExch',
            'DealerConractInfo' => '\\StructType\\DealerConractInfo',
            'AgentConract' => '\\StructType\\AgentConract',
            'GeneralConract' => '\\StructType\\GeneralConract',
            'PointOfSale' => '\\StructType\\PointOfSale',
            'UserInfo' => '\\StructType\\UserInfo',
            'PaymentList' => '\\StructType\\PaymentList',
            'Payment' => '\\StructType\\Payment',
            'PaymentDocument' => '\\StructType\\PaymentDocument',
            'AgentSubject' => '\\StructType\\AgentSubject',
            'InsuranceByPeriodList' => '\\StructType\\InsuranceByPeriodList',
            'InsuranceByPeriod' => '\\StructType\\InsuranceByPeriod',
            'MarketProgrList' => '\\StructType\\MarketProgrList',
            'ReasonsForReplacementList' => '\\StructType\\ReasonsForReplacementList',
            'PolicySequence' => '\\StructType\\PolicySequence',
            'BlankList' => '\\StructType\\BlankList',
            'BlankEntry' => '\\StructType\\BlankEntry',
            'SubjectChangesInfo' => '\\StructType\\SubjectChangesInfo',
            'PhysicalSubjectChangesInfo' => '\\StructType\\PhysicalSubjectChangesInfo',
            'JuridicalSubjectChanges' => '\\StructType\\JuridicalSubjectChanges',
            'SubjectRepresentative' => '\\StructType\\SubjectRepresentative',
            'BankRequisitesList' => '\\StructType\\BankRequisitesList',
            'BankRequisites' => '\\StructType\\BankRequisites',
            'Cross' => '\\StructType\\Cross',
            'Beneficiary' => '\\StructType\\Beneficiary',
            'PolicyStateHistoryList' => '\\StructType\\PolicyStateHistoryList',
            'PolicyStateItem' => '\\StructType\\PolicyStateItem',
            'DictionaryConstraint' => '\\StructType\\DictionaryConstraint',
            'Constraint' => '\\StructType\\Constraint',
            'DictionaryList' => '\\StructType\\DictionaryList',
            'DictionaryTypeList' => '\\StructType\\DictionaryTypeList',
            'DictionaryType' => '\\StructType\\DictionaryType',
            'ParameterDictionaryTypeList' => '\\StructType\\ParameterDictionaryTypeList',
            'ParameterDictionaryTypeInfo' => '\\StructType\\ParameterDictionaryTypeInfo',
            'CalcListCodes' => '\\StructType\\CalcListCodes',
            'Dictionary' => '\\StructType\\Dictionary',
            'DictionaryValue' => '\\StructType\\DictionaryValue',
            'ParameterDictionaryInfo' => '\\StructType\\ParameterDictionaryInfo',
            'ErrorList' => '\\StructType\\ErrorList',
            'Error' => '\\StructType\\Error',
            'DictionaryAttributeValueList' => '\\StructType\\DictionaryAttributeValueList',
            'DictionaryAttributeValue' => '\\StructType\\DictionaryAttributeValue',
            'ExcelDictionaryParameter' => '\\StructType\\ExcelDictionaryParameter',
            'ExcelDictionaryCodes' => '\\StructType\\ExcelDictionaryCodes',
            'ExcelDictionaryResult' => '\\StructType\\ExcelDictionaryResult',
            'DissolutionPolicyRequest' => '\\StructType\\DissolutionPolicyRequest',
            'Dissolution' => '\\StructType\\Dissolution',
            'DissolutionPolicyResponse' => '\\StructType\\DissolutionPolicyResponse',
            'CalcInsPremRequest' => '\\StructType\\CalcInsPremRequest',
            'ParamDefaultList' => '\\StructType\\ParamDefaultList',
            'CalcInsPremResponse' => '\\StructType\\CalcInsPremResponse',
            'CalcPolicyResultList' => '\\StructType\\CalcPolicyResultList',
            'CalcPolicyResult' => '\\StructType\\CalcPolicyResult',
            'ParamDefaultValuesList' => '\\StructType\\ParamDefaultValuesList',
            'getDictionaries' => '\\StructType\\GetDictionaries',
            'getDictionariesResponse' => '\\StructType\\GetDictionariesResponse',
            'HideLoginRequest' => '\\StructType\\HideLoginRequest',
            'LoginRequest' => '\\StructType\\LoginRequest',
            'HideLoginResponse' => '\\StructType\\HideLoginResponse',
            'PrintPolicyRequest' => '\\StructType\\PrintPolicyRequest',
            'PrintPolicyResponse' => '\\StructType\\PrintPolicyResponse',
            'IssuePolicyRequest' => '\\StructType\\IssuePolicyRequest',
            'IssuePolicyResponse' => '\\StructType\\IssuePolicyResponse',
            'AnnulPolicyRequest' => '\\StructType\\AnnulPolicyRequest',
            'AnnulPolicyResponse' => '\\StructType\\AnnulPolicyResponse',
            'RequestsReplacePolicyOwnerRequest' => '\\StructType\\RequestsReplacePolicyOwnerRequest',
            'RequestsReplacePolicyOwnerResponse' => '\\StructType\\RequestsReplacePolicyOwnerResponse',
            'LogOutResponse' => '\\StructType\\LogOutResponse',
            'GetPaymentURLRequest' => '\\StructType\\GetPaymentURLRequest',
            'GetPaymentURLResponse' => '\\StructType\\GetPaymentURLResponse',
            'ErrorWithCodeList' => '\\StructType\\ErrorWithCodeList',
            'ErrorWithCode' => '\\StructType\\ErrorWithCode',
            'AttachDocumentRequest' => '\\StructType\\AttachDocumentRequest',
            'AttachDocumentResponse' => '\\StructType\\AttachDocumentResponse',
            'SearchPoliciesRequest' => '\\StructType\\SearchPoliciesRequest',
            'SearchPoliciesResponse' => '\\StructType\\SearchPoliciesResponse',
            'PolicyShortInfoList' => '\\StructType\\PolicyShortInfoList',
            'PolicyShortInfo' => '\\StructType\\PolicyShortInfo',
            'IssuePolicyAsyncRequest' => '\\StructType\\IssuePolicyAsyncRequest',
            'IssuePolicyAsyncResponse' => '\\StructType\\IssuePolicyAsyncResponse',
            'getDictionaryValueCodesByAttribute' => '\\StructType\\GetDictionaryValueCodesByAttribute',
            'getDictionaryValueCodesByAttributeResponse' => '\\StructType\\GetDictionaryValueCodesByAttributeResponse',
            'getAllDictionariesExcel' => '\\StructType\\GetAllDictionariesExcel',
            'getAllDictionariesExcelResponse' => '\\StructType\\GetAllDictionariesExcelResponse',
            'ImportPolicyRequest' => '\\StructType\\ImportPolicyRequest',
            'ExternalSysUser' => '\\StructType\\ExternalSysUser',
            'ImportPolicyResponse' => '\\StructType\\ImportPolicyResponse',
            'getDictionaryAttributeValueByCode' => '\\StructType\\GetDictionaryAttributeValueByCode',
            'getDictionaryAttributeValueByCodeResponse' => '\\StructType\\GetDictionaryAttributeValueByCodeResponse',
            'GetIssueProcessStatusRequest' => '\\StructType\\GetIssueProcessStatusRequest',
            'GetIssueProcessStatusResponse' => '\\StructType\\GetIssueProcessStatusResponse',
            'GetPolicyRequest' => '\\StructType\\GetPolicyRequest',
            'GetPolicyResponse' => '\\StructType\\GetPolicyResponse',
            'LoginResponse' => '\\StructType\\LoginResponse',
            'getDictionaryByCode' => '\\StructType\\GetDictionaryByCode',
            'getDictionaryByCodeResponse' => '\\StructType\\GetDictionaryByCodeResponse',
            'ImportPolicyWOValidateResponse' => '\\StructType\\ImportPolicyWOValidateResponse',
        );
    }
}
