<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for AnnulPolicyResponse StructType
 * @subpackage Structs
 */
class AnnulPolicyResponse extends AbstractStructBase
{
    /**
     * The accID
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $accID;
    /**
     * The calcID
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $calcID;
    /**
     * The ok
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var bool
     */
    public $ok;
    /**
     * The errors
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var \StructType\ErrorList
     */
    public $errors;
    /**
     * Constructor method for AnnulPolicyResponse
     * @uses AnnulPolicyResponse::setAccID()
     * @uses AnnulPolicyResponse::setCalcID()
     * @uses AnnulPolicyResponse::setOk()
     * @uses AnnulPolicyResponse::setErrors()
     * @param string $accID
     * @param string $calcID
     * @param bool $ok
     * @param \StructType\ErrorList $errors
     */
    public function __construct($accID = null, $calcID = null, $ok = null, \StructType\ErrorList $errors = null)
    {
        $this
            ->setAccID($accID)
            ->setCalcID($calcID)
            ->setOk($ok)
            ->setErrors($errors);
    }
    /**
     * Get accID value
     * @return string|null
     */
    public function getAccID()
    {
        return $this->accID;
    }
    /**
     * Set accID value
     * @param string $accID
     * @return \StructType\AnnulPolicyResponse
     */
    public function setAccID($accID = null)
    {
        // validation for constraint: string
        if (!is_null($accID) && !is_string($accID)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($accID, true), gettype($accID)), __LINE__);
        }
        $this->accID = $accID;
        return $this;
    }
    /**
     * Get calcID value
     * @return string|null
     */
    public function getCalcID()
    {
        return $this->calcID;
    }
    /**
     * Set calcID value
     * @param string $calcID
     * @return \StructType\AnnulPolicyResponse
     */
    public function setCalcID($calcID = null)
    {
        // validation for constraint: string
        if (!is_null($calcID) && !is_string($calcID)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($calcID, true), gettype($calcID)), __LINE__);
        }
        $this->calcID = $calcID;
        return $this;
    }
    /**
     * Get ok value
     * @return bool|null
     */
    public function getOk()
    {
        return $this->ok;
    }
    /**
     * Set ok value
     * @param bool $ok
     * @return \StructType\AnnulPolicyResponse
     */
    public function setOk($ok = null)
    {
        // validation for constraint: boolean
        if (!is_null($ok) && !is_bool($ok)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a bool, %s given', var_export($ok, true), gettype($ok)), __LINE__);
        }
        $this->ok = $ok;
        return $this;
    }
    /**
     * Get errors value
     * @return \StructType\ErrorList|null
     */
    public function getErrors()
    {
        return $this->errors;
    }
    /**
     * Set errors value
     * @param \StructType\ErrorList $errors
     * @return \StructType\AnnulPolicyResponse
     */
    public function setErrors(\StructType\ErrorList $errors = null)
    {
        $this->errors = $errors;
        return $this;
    }
}
