<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for BusinessLicense StructType
 * @subpackage Structs
 */
class BusinessLicense extends AbstractStructBase
{
    /**
     * The type
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $type;
    /**
     * The number
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $number;
    /**
     * The dateOfIssue
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $dateOfIssue;
    /**
     * The placeOfIssue
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $placeOfIssue;
    /**
     * The dateBegin
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var anySimpleType
     */
    public $dateBegin;
    /**
     * The dateEnd
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var anySimpleType
     */
    public $dateEnd;
    /**
     * The activity
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $activity;
    /**
     * Constructor method for BusinessLicense
     * @uses BusinessLicense::setType()
     * @uses BusinessLicense::setNumber()
     * @uses BusinessLicense::setDateOfIssue()
     * @uses BusinessLicense::setPlaceOfIssue()
     * @uses BusinessLicense::setDateBegin()
     * @uses BusinessLicense::setDateEnd()
     * @uses BusinessLicense::setActivity()
     * @param string $type
     * @param string $number
     * @param string $dateOfIssue
     * @param string $placeOfIssue
     * @param anySimpleType $dateBegin
     * @param anySimpleType $dateEnd
     * @param string $activity
     */
    public function __construct($type = null, $number = null, $dateOfIssue = null, $placeOfIssue = null, anySimpleType $dateBegin = null, anySimpleType $dateEnd = null, $activity = null)
    {
        $this
            ->setType($type)
            ->setNumber($number)
            ->setDateOfIssue($dateOfIssue)
            ->setPlaceOfIssue($placeOfIssue)
            ->setDateBegin($dateBegin)
            ->setDateEnd($dateEnd)
            ->setActivity($activity);
    }
    /**
     * Get type value
     * @return string|null
     */
    public function getType()
    {
        return $this->type;
    }
    /**
     * Set type value
     * @param string $type
     * @return \StructType\BusinessLicense
     */
    public function setType($type = null)
    {
        // validation for constraint: string
        if (!is_null($type) && !is_string($type)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($type, true), gettype($type)), __LINE__);
        }
        $this->type = $type;
        return $this;
    }
    /**
     * Get number value
     * @return string|null
     */
    public function getNumber()
    {
        return $this->number;
    }
    /**
     * Set number value
     * @param string $number
     * @return \StructType\BusinessLicense
     */
    public function setNumber($number = null)
    {
        // validation for constraint: string
        if (!is_null($number) && !is_string($number)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($number, true), gettype($number)), __LINE__);
        }
        $this->number = $number;
        return $this;
    }
    /**
     * Get dateOfIssue value
     * @return string|null
     */
    public function getDateOfIssue()
    {
        return $this->dateOfIssue;
    }
    /**
     * Set dateOfIssue value
     * @param string $dateOfIssue
     * @return \StructType\BusinessLicense
     */
    public function setDateOfIssue($dateOfIssue = null)
    {
        // validation for constraint: string
        if (!is_null($dateOfIssue) && !is_string($dateOfIssue)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($dateOfIssue, true), gettype($dateOfIssue)), __LINE__);
        }
        $this->dateOfIssue = $dateOfIssue;
        return $this;
    }
    /**
     * Get placeOfIssue value
     * @return string|null
     */
    public function getPlaceOfIssue()
    {
        return $this->placeOfIssue;
    }
    /**
     * Set placeOfIssue value
     * @param string $placeOfIssue
     * @return \StructType\BusinessLicense
     */
    public function setPlaceOfIssue($placeOfIssue = null)
    {
        // validation for constraint: string
        if (!is_null($placeOfIssue) && !is_string($placeOfIssue)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($placeOfIssue, true), gettype($placeOfIssue)), __LINE__);
        }
        $this->placeOfIssue = $placeOfIssue;
        return $this;
    }
    /**
     * Get dateBegin value
     * @return anySimpleType|null
     */
    public function getDateBegin()
    {
        return $this->dateBegin;
    }
    /**
     * Set dateBegin value
     * @param anySimpleType $dateBegin
     * @return \StructType\BusinessLicense
     */
    public function setDateBegin(anySimpleType $dateBegin = null)
    {
        $this->dateBegin = $dateBegin;
        return $this;
    }
    /**
     * Get dateEnd value
     * @return anySimpleType|null
     */
    public function getDateEnd()
    {
        return $this->dateEnd;
    }
    /**
     * Set dateEnd value
     * @param anySimpleType $dateEnd
     * @return \StructType\BusinessLicense
     */
    public function setDateEnd(anySimpleType $dateEnd = null)
    {
        $this->dateEnd = $dateEnd;
        return $this;
    }
    /**
     * Get activity value
     * @return string|null
     */
    public function getActivity()
    {
        return $this->activity;
    }
    /**
     * Set activity value
     * @param string $activity
     * @return \StructType\BusinessLicense
     */
    public function setActivity($activity = null)
    {
        // validation for constraint: string
        if (!is_null($activity) && !is_string($activity)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($activity, true), gettype($activity)), __LINE__);
        }
        $this->activity = $activity;
        return $this;
    }
}
