<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for CalcInsPremRequest StructType
 * Meta information extracted from the WSDL
 * - type: tns:CalcInsPremRequest
 * @subpackage Structs
 */
class CalcInsPremRequest extends AbstractStructBase
{
    /**
     * The accID
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $accID;
    /**
     * The productType
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $productType;
    /**
     * The policyCalc
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var \StructType\Policy
     */
    public $policyCalc;
    /**
     * The paramDefaultList
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var \StructType\ParamDefaultList
     */
    public $paramDefaultList;
    /**
     * Constructor method for CalcInsPremRequest
     * @uses CalcInsPremRequest::setAccID()
     * @uses CalcInsPremRequest::setProductType()
     * @uses CalcInsPremRequest::setPolicyCalc()
     * @uses CalcInsPremRequest::setParamDefaultList()
     * @param string $accID
     * @param string $productType
     * @param \StructType\Policy $policyCalc
     * @param \StructType\ParamDefaultList $paramDefaultList
     */
    public function __construct($accID = null, $productType = null, \StructType\Policy $policyCalc = null, \StructType\ParamDefaultList $paramDefaultList = null)
    {
        $this
            ->setAccID($accID)
            ->setProductType($productType)
            ->setPolicyCalc($policyCalc)
            ->setParamDefaultList($paramDefaultList);
    }
    /**
     * Get accID value
     * @return string|null
     */
    public function getAccID()
    {
        return $this->accID;
    }
    /**
     * Set accID value
     * @param string $accID
     * @return \StructType\CalcInsPremRequest
     */
    public function setAccID($accID = null)
    {
        // validation for constraint: string
        if (!is_null($accID) && !is_string($accID)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($accID, true), gettype($accID)), __LINE__);
        }
        $this->accID = $accID;
        return $this;
    }
    /**
     * Get productType value
     * @return string|null
     */
    public function getProductType()
    {
        return $this->productType;
    }
    /**
     * Set productType value
     * @param string $productType
     * @return \StructType\CalcInsPremRequest
     */
    public function setProductType($productType = null)
    {
        // validation for constraint: string
        if (!is_null($productType) && !is_string($productType)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($productType, true), gettype($productType)), __LINE__);
        }
        $this->productType = $productType;
        return $this;
    }
    /**
     * Get policyCalc value
     * @return \StructType\Policy|null
     */
    public function getPolicyCalc()
    {
        return $this->policyCalc;
    }
    /**
     * Set policyCalc value
     * @param \StructType\Policy $policyCalc
     * @return \StructType\CalcInsPremRequest
     */
    public function setPolicyCalc(\StructType\Policy $policyCalc = null)
    {
        $this->policyCalc = $policyCalc;
        return $this;
    }
    /**
     * Get paramDefaultList value
     * @return \StructType\ParamDefaultList|null
     */
    public function getParamDefaultList()
    {
        return $this->paramDefaultList;
    }
    /**
     * Set paramDefaultList value
     * @param \StructType\ParamDefaultList $paramDefaultList
     * @return \StructType\CalcInsPremRequest
     */
    public function setParamDefaultList(\StructType\ParamDefaultList $paramDefaultList = null)
    {
        $this->paramDefaultList = $paramDefaultList;
        return $this;
    }
}
