<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for CalcInsPremResponse StructType
 * Meta information extracted from the WSDL
 * - type: tns:CalcInsPremResponse
 * @subpackage Structs
 */
class CalcInsPremResponse extends AbstractStructBase
{
    /**
     * The accID
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $accID;
    /**
     * The calcPolicyResult
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var \StructType\CalcPolicyResultList
     */
    public $calcPolicyResult;
    /**
     * The errors
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var \StructType\ErrorList
     */
    public $errors;
    /**
     * Constructor method for CalcInsPremResponse
     * @uses CalcInsPremResponse::setAccID()
     * @uses CalcInsPremResponse::setCalcPolicyResult()
     * @uses CalcInsPremResponse::setErrors()
     * @param string $accID
     * @param \StructType\CalcPolicyResultList $calcPolicyResult
     * @param \StructType\ErrorList $errors
     */
    public function __construct($accID = null, \StructType\CalcPolicyResultList $calcPolicyResult = null, \StructType\ErrorList $errors = null)
    {
        $this
            ->setAccID($accID)
            ->setCalcPolicyResult($calcPolicyResult)
            ->setErrors($errors);
    }
    /**
     * Get accID value
     * @return string|null
     */
    public function getAccID()
    {
        return $this->accID;
    }
    /**
     * Set accID value
     * @param string $accID
     * @return \StructType\CalcInsPremResponse
     */
    public function setAccID($accID = null)
    {
        // validation for constraint: string
        if (!is_null($accID) && !is_string($accID)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($accID, true), gettype($accID)), __LINE__);
        }
        $this->accID = $accID;
        return $this;
    }
    /**
     * Get calcPolicyResult value
     * @return \StructType\CalcPolicyResultList|null
     */
    public function getCalcPolicyResult()
    {
        return $this->calcPolicyResult;
    }
    /**
     * Set calcPolicyResult value
     * @param \StructType\CalcPolicyResultList $calcPolicyResult
     * @return \StructType\CalcInsPremResponse
     */
    public function setCalcPolicyResult(\StructType\CalcPolicyResultList $calcPolicyResult = null)
    {
        $this->calcPolicyResult = $calcPolicyResult;
        return $this;
    }
    /**
     * Get errors value
     * @return \StructType\ErrorList|null
     */
    public function getErrors()
    {
        return $this->errors;
    }
    /**
     * Set errors value
     * @param \StructType\ErrorList $errors
     * @return \StructType\CalcInsPremResponse
     */
    public function setErrors(\StructType\ErrorList $errors = null)
    {
        $this->errors = $errors;
        return $this;
    }
}
