<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for CalcPolicyResultList StructType
 * @subpackage Structs
 */
class CalcPolicyResultList extends AbstractStructBase
{
    /**
     * The calcResult
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * @var \StructType\CalcPolicyResult[]
     */
    public $calcResult;
    /**
     * Constructor method for CalcPolicyResultList
     * @uses CalcPolicyResultList::setCalcResult()
     * @param \StructType\CalcPolicyResult[] $calcResult
     */
    public function __construct(array $calcResult = array())
    {
        $this
            ->setCalcResult($calcResult);
    }
    /**
     * Get calcResult value
     * @return \StructType\CalcPolicyResult[]|null
     */
    public function getCalcResult()
    {
        return $this->calcResult;
    }
    /**
     * This method is responsible for validating the values passed to the setCalcResult method
     * This method is willingly generated in order to preserve the one-line inline validation within the setCalcResult method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateCalcResultForArrayConstraintsFromSetCalcResult(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $calcPolicyResultListCalcResultItem) {
            // validation for constraint: itemType
            if (!$calcPolicyResultListCalcResultItem instanceof \StructType\CalcPolicyResult) {
                $invalidValues[] = is_object($calcPolicyResultListCalcResultItem) ? get_class($calcPolicyResultListCalcResultItem) : sprintf('%s(%s)', gettype($calcPolicyResultListCalcResultItem), var_export($calcPolicyResultListCalcResultItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The calcResult property can only contain items of type \StructType\CalcPolicyResult, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set calcResult value
     * @throws \InvalidArgumentException
     * @param \StructType\CalcPolicyResult[] $calcResult
     * @return \StructType\CalcPolicyResultList
     */
    public function setCalcResult(array $calcResult = array())
    {
        // validation for constraint: array
        if ('' !== ($calcResultArrayErrorMessage = self::validateCalcResultForArrayConstraintsFromSetCalcResult($calcResult))) {
            throw new \InvalidArgumentException($calcResultArrayErrorMessage, __LINE__);
        }
        $this->calcResult = $calcResult;
        return $this;
    }
    /**
     * Add item to calcResult value
     * @throws \InvalidArgumentException
     * @param \StructType\CalcPolicyResult $item
     * @return \StructType\CalcPolicyResultList
     */
    public function addToCalcResult(\StructType\CalcPolicyResult $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\CalcPolicyResult) {
            throw new \InvalidArgumentException(sprintf('The calcResult property can only contain items of type \StructType\CalcPolicyResult, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->calcResult[] = $item;
        return $this;
    }
}
