<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for CurrencyExchList StructType
 * @subpackage Structs
 */
class CurrencyExchList extends AbstractStructBase
{
    /**
     * The currExch
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * @var \StructType\CurrencyExch[]
     */
    public $currExch;
    /**
     * Constructor method for CurrencyExchList
     * @uses CurrencyExchList::setCurrExch()
     * @param \StructType\CurrencyExch[] $currExch
     */
    public function __construct(array $currExch = array())
    {
        $this
            ->setCurrExch($currExch);
    }
    /**
     * Get currExch value
     * @return \StructType\CurrencyExch[]|null
     */
    public function getCurrExch()
    {
        return $this->currExch;
    }
    /**
     * This method is responsible for validating the values passed to the setCurrExch method
     * This method is willingly generated in order to preserve the one-line inline validation within the setCurrExch method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateCurrExchForArrayConstraintsFromSetCurrExch(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $currencyExchListCurrExchItem) {
            // validation for constraint: itemType
            if (!$currencyExchListCurrExchItem instanceof \StructType\CurrencyExch) {
                $invalidValues[] = is_object($currencyExchListCurrExchItem) ? get_class($currencyExchListCurrExchItem) : sprintf('%s(%s)', gettype($currencyExchListCurrExchItem), var_export($currencyExchListCurrExchItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The currExch property can only contain items of type \StructType\CurrencyExch, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set currExch value
     * @throws \InvalidArgumentException
     * @param \StructType\CurrencyExch[] $currExch
     * @return \StructType\CurrencyExchList
     */
    public function setCurrExch(array $currExch = array())
    {
        // validation for constraint: array
        if ('' !== ($currExchArrayErrorMessage = self::validateCurrExchForArrayConstraintsFromSetCurrExch($currExch))) {
            throw new \InvalidArgumentException($currExchArrayErrorMessage, __LINE__);
        }
        $this->currExch = $currExch;
        return $this;
    }
    /**
     * Add item to currExch value
     * @throws \InvalidArgumentException
     * @param \StructType\CurrencyExch $item
     * @return \StructType\CurrencyExchList
     */
    public function addToCurrExch(\StructType\CurrencyExch $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\CurrencyExch) {
            throw new \InvalidArgumentException(sprintf('The currExch property can only contain items of type \StructType\CurrencyExch, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->currExch[] = $item;
        return $this;
    }
}
