<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for IdentifBeneficiarListInfo StructType
 * @subpackage Structs
 */
class IdentifBeneficiarListInfo extends AbstractStructBase
{
    /**
     * The beneficiari
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * @var \StructType\IdentifBeneficiarInfo[]
     */
    public $beneficiari;
    /**
     * Constructor method for IdentifBeneficiarListInfo
     * @uses IdentifBeneficiarListInfo::setBeneficiari()
     * @param \StructType\IdentifBeneficiarInfo[] $beneficiari
     */
    public function __construct(array $beneficiari = array())
    {
        $this
            ->setBeneficiari($beneficiari);
    }
    /**
     * Get beneficiari value
     * @return \StructType\IdentifBeneficiarInfo[]|null
     */
    public function getBeneficiari()
    {
        return $this->beneficiari;
    }
    /**
     * This method is responsible for validating the values passed to the setBeneficiari method
     * This method is willingly generated in order to preserve the one-line inline validation within the setBeneficiari method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateBeneficiariForArrayConstraintsFromSetBeneficiari(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $identifBeneficiarListInfoBeneficiariItem) {
            // validation for constraint: itemType
            if (!$identifBeneficiarListInfoBeneficiariItem instanceof \StructType\IdentifBeneficiarInfo) {
                $invalidValues[] = is_object($identifBeneficiarListInfoBeneficiariItem) ? get_class($identifBeneficiarListInfoBeneficiariItem) : sprintf('%s(%s)', gettype($identifBeneficiarListInfoBeneficiariItem), var_export($identifBeneficiarListInfoBeneficiariItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The beneficiari property can only contain items of type \StructType\IdentifBeneficiarInfo, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set beneficiari value
     * @throws \InvalidArgumentException
     * @param \StructType\IdentifBeneficiarInfo[] $beneficiari
     * @return \StructType\IdentifBeneficiarListInfo
     */
    public function setBeneficiari(array $beneficiari = array())
    {
        // validation for constraint: array
        if ('' !== ($beneficiariArrayErrorMessage = self::validateBeneficiariForArrayConstraintsFromSetBeneficiari($beneficiari))) {
            throw new \InvalidArgumentException($beneficiariArrayErrorMessage, __LINE__);
        }
        $this->beneficiari = $beneficiari;
        return $this;
    }
    /**
     * Add item to beneficiari value
     * @throws \InvalidArgumentException
     * @param \StructType\IdentifBeneficiarInfo $item
     * @return \StructType\IdentifBeneficiarListInfo
     */
    public function addToBeneficiari(\StructType\IdentifBeneficiarInfo $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\IdentifBeneficiarInfo) {
            throw new \InvalidArgumentException(sprintf('The beneficiari property can only contain items of type \StructType\IdentifBeneficiarInfo, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->beneficiari[] = $item;
        return $this;
    }
}
