<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for InsuranceByPeriodList StructType
 * @subpackage Structs
 */
class InsuranceByPeriodList extends AbstractStructBase
{
    /**
     * The insByPeriod
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * @var \StructType\InsuranceByPeriod[]
     */
    public $insByPeriod;
    /**
     * Constructor method for InsuranceByPeriodList
     * @uses InsuranceByPeriodList::setInsByPeriod()
     * @param \StructType\InsuranceByPeriod[] $insByPeriod
     */
    public function __construct(array $insByPeriod = array())
    {
        $this
            ->setInsByPeriod($insByPeriod);
    }
    /**
     * Get insByPeriod value
     * @return \StructType\InsuranceByPeriod[]|null
     */
    public function getInsByPeriod()
    {
        return $this->insByPeriod;
    }
    /**
     * This method is responsible for validating the values passed to the setInsByPeriod method
     * This method is willingly generated in order to preserve the one-line inline validation within the setInsByPeriod method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateInsByPeriodForArrayConstraintsFromSetInsByPeriod(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $insuranceByPeriodListInsByPeriodItem) {
            // validation for constraint: itemType
            if (!$insuranceByPeriodListInsByPeriodItem instanceof \StructType\InsuranceByPeriod) {
                $invalidValues[] = is_object($insuranceByPeriodListInsByPeriodItem) ? get_class($insuranceByPeriodListInsByPeriodItem) : sprintf('%s(%s)', gettype($insuranceByPeriodListInsByPeriodItem), var_export($insuranceByPeriodListInsByPeriodItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The insByPeriod property can only contain items of type \StructType\InsuranceByPeriod, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set insByPeriod value
     * @throws \InvalidArgumentException
     * @param \StructType\InsuranceByPeriod[] $insByPeriod
     * @return \StructType\InsuranceByPeriodList
     */
    public function setInsByPeriod(array $insByPeriod = array())
    {
        // validation for constraint: array
        if ('' !== ($insByPeriodArrayErrorMessage = self::validateInsByPeriodForArrayConstraintsFromSetInsByPeriod($insByPeriod))) {
            throw new \InvalidArgumentException($insByPeriodArrayErrorMessage, __LINE__);
        }
        $this->insByPeriod = $insByPeriod;
        return $this;
    }
    /**
     * Add item to insByPeriod value
     * @throws \InvalidArgumentException
     * @param \StructType\InsuranceByPeriod $item
     * @return \StructType\InsuranceByPeriodList
     */
    public function addToInsByPeriod(\StructType\InsuranceByPeriod $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\InsuranceByPeriod) {
            throw new \InvalidArgumentException(sprintf('The insByPeriod property can only contain items of type \StructType\InsuranceByPeriod, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->insByPeriod[] = $item;
        return $this;
    }
}
