<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for JuridicalSubjectChanges StructType
 * @subpackage Structs
 */
class JuridicalSubjectChanges extends AbstractStructBase
{
    /**
     * The fullNameChanged
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var bool
     */
    public $fullNameChanged;
    /**
     * The fullNamePrev
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $fullNamePrev;
    /**
     * The innPrev
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $innPrev;
    /**
     * The rezidentPrev
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var bool
     */
    public $rezidentPrev;
    /**
     * Constructor method for JuridicalSubjectChanges
     * @uses JuridicalSubjectChanges::setFullNameChanged()
     * @uses JuridicalSubjectChanges::setFullNamePrev()
     * @uses JuridicalSubjectChanges::setInnPrev()
     * @uses JuridicalSubjectChanges::setRezidentPrev()
     * @param bool $fullNameChanged
     * @param string $fullNamePrev
     * @param string $innPrev
     * @param bool $rezidentPrev
     */
    public function __construct($fullNameChanged = null, $fullNamePrev = null, $innPrev = null, $rezidentPrev = null)
    {
        $this
            ->setFullNameChanged($fullNameChanged)
            ->setFullNamePrev($fullNamePrev)
            ->setInnPrev($innPrev)
            ->setRezidentPrev($rezidentPrev);
    }
    /**
     * Get fullNameChanged value
     * @return bool|null
     */
    public function getFullNameChanged()
    {
        return $this->fullNameChanged;
    }
    /**
     * Set fullNameChanged value
     * @param bool $fullNameChanged
     * @return \StructType\JuridicalSubjectChanges
     */
    public function setFullNameChanged($fullNameChanged = null)
    {
        // validation for constraint: boolean
        if (!is_null($fullNameChanged) && !is_bool($fullNameChanged)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a bool, %s given', var_export($fullNameChanged, true), gettype($fullNameChanged)), __LINE__);
        }
        $this->fullNameChanged = $fullNameChanged;
        return $this;
    }
    /**
     * Get fullNamePrev value
     * @return string|null
     */
    public function getFullNamePrev()
    {
        return $this->fullNamePrev;
    }
    /**
     * Set fullNamePrev value
     * @param string $fullNamePrev
     * @return \StructType\JuridicalSubjectChanges
     */
    public function setFullNamePrev($fullNamePrev = null)
    {
        // validation for constraint: string
        if (!is_null($fullNamePrev) && !is_string($fullNamePrev)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($fullNamePrev, true), gettype($fullNamePrev)), __LINE__);
        }
        $this->fullNamePrev = $fullNamePrev;
        return $this;
    }
    /**
     * Get innPrev value
     * @return string|null
     */
    public function getInnPrev()
    {
        return $this->innPrev;
    }
    /**
     * Set innPrev value
     * @param string $innPrev
     * @return \StructType\JuridicalSubjectChanges
     */
    public function setInnPrev($innPrev = null)
    {
        // validation for constraint: string
        if (!is_null($innPrev) && !is_string($innPrev)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($innPrev, true), gettype($innPrev)), __LINE__);
        }
        $this->innPrev = $innPrev;
        return $this;
    }
    /**
     * Get rezidentPrev value
     * @return bool|null
     */
    public function getRezidentPrev()
    {
        return $this->rezidentPrev;
    }
    /**
     * Set rezidentPrev value
     * @param bool $rezidentPrev
     * @return \StructType\JuridicalSubjectChanges
     */
    public function setRezidentPrev($rezidentPrev = null)
    {
        // validation for constraint: boolean
        if (!is_null($rezidentPrev) && !is_bool($rezidentPrev)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a bool, %s given', var_export($rezidentPrev, true), gettype($rezidentPrev)), __LINE__);
        }
        $this->rezidentPrev = $rezidentPrev;
        return $this;
    }
}
