<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for ParameterDictionaryTypeList StructType
 * Meta information extracted from the WSDL
 * - type: tns:ParameterDictionaryTypeList
 * @subpackage Structs
 */
class ParameterDictionaryTypeList extends AbstractStructBase
{
    /**
     * The ParameterType
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * @var \StructType\ParameterDictionaryTypeInfo[]
     */
    public $ParameterType;
    /**
     * Constructor method for ParameterDictionaryTypeList
     * @uses ParameterDictionaryTypeList::setParameterType()
     * @param \StructType\ParameterDictionaryTypeInfo[] $parameterType
     */
    public function __construct(array $parameterType = array())
    {
        $this
            ->setParameterType($parameterType);
    }
    /**
     * Get ParameterType value
     * @return \StructType\ParameterDictionaryTypeInfo[]|null
     */
    public function getParameterType()
    {
        return $this->ParameterType;
    }
    /**
     * This method is responsible for validating the values passed to the setParameterType method
     * This method is willingly generated in order to preserve the one-line inline validation within the setParameterType method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateParameterTypeForArrayConstraintsFromSetParameterType(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $parameterDictionaryTypeListParameterTypeItem) {
            // validation for constraint: itemType
            if (!$parameterDictionaryTypeListParameterTypeItem instanceof \StructType\ParameterDictionaryTypeInfo) {
                $invalidValues[] = is_object($parameterDictionaryTypeListParameterTypeItem) ? get_class($parameterDictionaryTypeListParameterTypeItem) : sprintf('%s(%s)', gettype($parameterDictionaryTypeListParameterTypeItem), var_export($parameterDictionaryTypeListParameterTypeItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The ParameterType property can only contain items of type \StructType\ParameterDictionaryTypeInfo, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set ParameterType value
     * @throws \InvalidArgumentException
     * @param \StructType\ParameterDictionaryTypeInfo[] $parameterType
     * @return \StructType\ParameterDictionaryTypeList
     */
    public function setParameterType(array $parameterType = array())
    {
        // validation for constraint: array
        if ('' !== ($parameterTypeArrayErrorMessage = self::validateParameterTypeForArrayConstraintsFromSetParameterType($parameterType))) {
            throw new \InvalidArgumentException($parameterTypeArrayErrorMessage, __LINE__);
        }
        $this->ParameterType = $parameterType;
        return $this;
    }
    /**
     * Add item to ParameterType value
     * @throws \InvalidArgumentException
     * @param \StructType\ParameterDictionaryTypeInfo $item
     * @return \StructType\ParameterDictionaryTypeList
     */
    public function addToParameterType(\StructType\ParameterDictionaryTypeInfo $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\ParameterDictionaryTypeInfo) {
            throw new \InvalidArgumentException(sprintf('The ParameterType property can only contain items of type \StructType\ParameterDictionaryTypeInfo, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->ParameterType[] = $item;
        return $this;
    }
}
