<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for PhysicalSubjectChangesInfo StructType
 * @subpackage Structs
 */
class PhysicalSubjectChangesInfo extends AbstractStructBase
{
    /**
     * The fullNameChanged
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var bool
     */
    public $fullNameChanged;
    /**
     * The documentChanged
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var bool
     */
    public $documentChanged;
    /**
     * The lastNamePrev
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $lastNamePrev;
    /**
     * The firstNamePrev
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $firstNamePrev;
    /**
     * The middleNamePrev
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $middleNamePrev;
    /**
     * The documentPrev
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var \StructType\DocumentInfo
     */
    public $documentPrev;
    /**
     * Constructor method for PhysicalSubjectChangesInfo
     * @uses PhysicalSubjectChangesInfo::setFullNameChanged()
     * @uses PhysicalSubjectChangesInfo::setDocumentChanged()
     * @uses PhysicalSubjectChangesInfo::setLastNamePrev()
     * @uses PhysicalSubjectChangesInfo::setFirstNamePrev()
     * @uses PhysicalSubjectChangesInfo::setMiddleNamePrev()
     * @uses PhysicalSubjectChangesInfo::setDocumentPrev()
     * @param bool $fullNameChanged
     * @param bool $documentChanged
     * @param string $lastNamePrev
     * @param string $firstNamePrev
     * @param string $middleNamePrev
     * @param \StructType\DocumentInfo $documentPrev
     */
    public function __construct($fullNameChanged = null, $documentChanged = null, $lastNamePrev = null, $firstNamePrev = null, $middleNamePrev = null, \StructType\DocumentInfo $documentPrev = null)
    {
        $this
            ->setFullNameChanged($fullNameChanged)
            ->setDocumentChanged($documentChanged)
            ->setLastNamePrev($lastNamePrev)
            ->setFirstNamePrev($firstNamePrev)
            ->setMiddleNamePrev($middleNamePrev)
            ->setDocumentPrev($documentPrev);
    }
    /**
     * Get fullNameChanged value
     * @return bool|null
     */
    public function getFullNameChanged()
    {
        return $this->fullNameChanged;
    }
    /**
     * Set fullNameChanged value
     * @param bool $fullNameChanged
     * @return \StructType\PhysicalSubjectChangesInfo
     */
    public function setFullNameChanged($fullNameChanged = null)
    {
        // validation for constraint: boolean
        if (!is_null($fullNameChanged) && !is_bool($fullNameChanged)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a bool, %s given', var_export($fullNameChanged, true), gettype($fullNameChanged)), __LINE__);
        }
        $this->fullNameChanged = $fullNameChanged;
        return $this;
    }
    /**
     * Get documentChanged value
     * @return bool|null
     */
    public function getDocumentChanged()
    {
        return $this->documentChanged;
    }
    /**
     * Set documentChanged value
     * @param bool $documentChanged
     * @return \StructType\PhysicalSubjectChangesInfo
     */
    public function setDocumentChanged($documentChanged = null)
    {
        // validation for constraint: boolean
        if (!is_null($documentChanged) && !is_bool($documentChanged)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a bool, %s given', var_export($documentChanged, true), gettype($documentChanged)), __LINE__);
        }
        $this->documentChanged = $documentChanged;
        return $this;
    }
    /**
     * Get lastNamePrev value
     * @return string|null
     */
    public function getLastNamePrev()
    {
        return $this->lastNamePrev;
    }
    /**
     * Set lastNamePrev value
     * @param string $lastNamePrev
     * @return \StructType\PhysicalSubjectChangesInfo
     */
    public function setLastNamePrev($lastNamePrev = null)
    {
        // validation for constraint: string
        if (!is_null($lastNamePrev) && !is_string($lastNamePrev)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($lastNamePrev, true), gettype($lastNamePrev)), __LINE__);
        }
        $this->lastNamePrev = $lastNamePrev;
        return $this;
    }
    /**
     * Get firstNamePrev value
     * @return string|null
     */
    public function getFirstNamePrev()
    {
        return $this->firstNamePrev;
    }
    /**
     * Set firstNamePrev value
     * @param string $firstNamePrev
     * @return \StructType\PhysicalSubjectChangesInfo
     */
    public function setFirstNamePrev($firstNamePrev = null)
    {
        // validation for constraint: string
        if (!is_null($firstNamePrev) && !is_string($firstNamePrev)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($firstNamePrev, true), gettype($firstNamePrev)), __LINE__);
        }
        $this->firstNamePrev = $firstNamePrev;
        return $this;
    }
    /**
     * Get middleNamePrev value
     * @return string|null
     */
    public function getMiddleNamePrev()
    {
        return $this->middleNamePrev;
    }
    /**
     * Set middleNamePrev value
     * @param string $middleNamePrev
     * @return \StructType\PhysicalSubjectChangesInfo
     */
    public function setMiddleNamePrev($middleNamePrev = null)
    {
        // validation for constraint: string
        if (!is_null($middleNamePrev) && !is_string($middleNamePrev)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($middleNamePrev, true), gettype($middleNamePrev)), __LINE__);
        }
        $this->middleNamePrev = $middleNamePrev;
        return $this;
    }
    /**
     * Get documentPrev value
     * @return \StructType\DocumentInfo|null
     */
    public function getDocumentPrev()
    {
        return $this->documentPrev;
    }
    /**
     * Set documentPrev value
     * @param \StructType\DocumentInfo $documentPrev
     * @return \StructType\PhysicalSubjectChangesInfo
     */
    public function setDocumentPrev(\StructType\DocumentInfo $documentPrev = null)
    {
        $this->documentPrev = $documentPrev;
        return $this;
    }
}
