<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for PolicyShortInfo StructType
 * @subpackage Structs
 */
class PolicyShortInfo extends AbstractStructBase
{
    /**
     * The internalID
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var int
     */
    public $internalID;
    /**
     * The calcID
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $calcID;
    /**
     * The number
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $number;
    /**
     * The produkt
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $produkt;
    /**
     * The insurant
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $insurant;
    /**
     * The insObjectSummary
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $insObjectSummary;
    /**
     * The pointOfSale
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $pointOfSale;
    /**
     * The user
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $user;
    /**
     * The premium
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $premium;
    /**
     * The premiumRur
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $premiumRur;
    /**
     * The state
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $state;
    /**
     * The date
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $date;
    /**
     * The dateBeg
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $dateBeg;
    /**
     * The dateEnd
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $dateEnd;
    /**
     * Constructor method for PolicyShortInfo
     * @uses PolicyShortInfo::setInternalID()
     * @uses PolicyShortInfo::setCalcID()
     * @uses PolicyShortInfo::setNumber()
     * @uses PolicyShortInfo::setProdukt()
     * @uses PolicyShortInfo::setInsurant()
     * @uses PolicyShortInfo::setInsObjectSummary()
     * @uses PolicyShortInfo::setPointOfSale()
     * @uses PolicyShortInfo::setUser()
     * @uses PolicyShortInfo::setPremium()
     * @uses PolicyShortInfo::setPremiumRur()
     * @uses PolicyShortInfo::setState()
     * @uses PolicyShortInfo::setDate()
     * @uses PolicyShortInfo::setDateBeg()
     * @uses PolicyShortInfo::setDateEnd()
     * @param int $internalID
     * @param string $calcID
     * @param string $number
     * @param string $produkt
     * @param string $insurant
     * @param string $insObjectSummary
     * @param string $pointOfSale
     * @param string $user
     * @param string $premium
     * @param string $premiumRur
     * @param string $state
     * @param string $date
     * @param string $dateBeg
     * @param string $dateEnd
     */
    public function __construct($internalID = null, $calcID = null, $number = null, $produkt = null, $insurant = null, $insObjectSummary = null, $pointOfSale = null, $user = null, $premium = null, $premiumRur = null, $state = null, $date = null, $dateBeg = null, $dateEnd = null)
    {
        $this
            ->setInternalID($internalID)
            ->setCalcID($calcID)
            ->setNumber($number)
            ->setProdukt($produkt)
            ->setInsurant($insurant)
            ->setInsObjectSummary($insObjectSummary)
            ->setPointOfSale($pointOfSale)
            ->setUser($user)
            ->setPremium($premium)
            ->setPremiumRur($premiumRur)
            ->setState($state)
            ->setDate($date)
            ->setDateBeg($dateBeg)
            ->setDateEnd($dateEnd);
    }
    /**
     * Get internalID value
     * @return int|null
     */
    public function getInternalID()
    {
        return $this->internalID;
    }
    /**
     * Set internalID value
     * @param int $internalID
     * @return \StructType\PolicyShortInfo
     */
    public function setInternalID($internalID = null)
    {
        // validation for constraint: int
        if (!is_null($internalID) && !(is_int($internalID) || ctype_digit($internalID))) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide an integer value, %s given', var_export($internalID, true), gettype($internalID)), __LINE__);
        }
        $this->internalID = $internalID;
        return $this;
    }
    /**
     * Get calcID value
     * @return string|null
     */
    public function getCalcID()
    {
        return $this->calcID;
    }
    /**
     * Set calcID value
     * @param string $calcID
     * @return \StructType\PolicyShortInfo
     */
    public function setCalcID($calcID = null)
    {
        // validation for constraint: string
        if (!is_null($calcID) && !is_string($calcID)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($calcID, true), gettype($calcID)), __LINE__);
        }
        $this->calcID = $calcID;
        return $this;
    }
    /**
     * Get number value
     * @return string|null
     */
    public function getNumber()
    {
        return $this->number;
    }
    /**
     * Set number value
     * @param string $number
     * @return \StructType\PolicyShortInfo
     */
    public function setNumber($number = null)
    {
        // validation for constraint: string
        if (!is_null($number) && !is_string($number)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($number, true), gettype($number)), __LINE__);
        }
        $this->number = $number;
        return $this;
    }
    /**
     * Get produkt value
     * @return string|null
     */
    public function getProdukt()
    {
        return $this->produkt;
    }
    /**
     * Set produkt value
     * @param string $produkt
     * @return \StructType\PolicyShortInfo
     */
    public function setProdukt($produkt = null)
    {
        // validation for constraint: string
        if (!is_null($produkt) && !is_string($produkt)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($produkt, true), gettype($produkt)), __LINE__);
        }
        $this->produkt = $produkt;
        return $this;
    }
    /**
     * Get insurant value
     * @return string|null
     */
    public function getInsurant()
    {
        return $this->insurant;
    }
    /**
     * Set insurant value
     * @param string $insurant
     * @return \StructType\PolicyShortInfo
     */
    public function setInsurant($insurant = null)
    {
        // validation for constraint: string
        if (!is_null($insurant) && !is_string($insurant)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($insurant, true), gettype($insurant)), __LINE__);
        }
        $this->insurant = $insurant;
        return $this;
    }
    /**
     * Get insObjectSummary value
     * @return string|null
     */
    public function getInsObjectSummary()
    {
        return $this->insObjectSummary;
    }
    /**
     * Set insObjectSummary value
     * @param string $insObjectSummary
     * @return \StructType\PolicyShortInfo
     */
    public function setInsObjectSummary($insObjectSummary = null)
    {
        // validation for constraint: string
        if (!is_null($insObjectSummary) && !is_string($insObjectSummary)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($insObjectSummary, true), gettype($insObjectSummary)), __LINE__);
        }
        $this->insObjectSummary = $insObjectSummary;
        return $this;
    }
    /**
     * Get pointOfSale value
     * @return string|null
     */
    public function getPointOfSale()
    {
        return $this->pointOfSale;
    }
    /**
     * Set pointOfSale value
     * @param string $pointOfSale
     * @return \StructType\PolicyShortInfo
     */
    public function setPointOfSale($pointOfSale = null)
    {
        // validation for constraint: string
        if (!is_null($pointOfSale) && !is_string($pointOfSale)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($pointOfSale, true), gettype($pointOfSale)), __LINE__);
        }
        $this->pointOfSale = $pointOfSale;
        return $this;
    }
    /**
     * Get user value
     * @return string|null
     */
    public function getUser()
    {
        return $this->user;
    }
    /**
     * Set user value
     * @param string $user
     * @return \StructType\PolicyShortInfo
     */
    public function setUser($user = null)
    {
        // validation for constraint: string
        if (!is_null($user) && !is_string($user)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($user, true), gettype($user)), __LINE__);
        }
        $this->user = $user;
        return $this;
    }
    /**
     * Get premium value
     * @return string|null
     */
    public function getPremium()
    {
        return $this->premium;
    }
    /**
     * Set premium value
     * @param string $premium
     * @return \StructType\PolicyShortInfo
     */
    public function setPremium($premium = null)
    {
        // validation for constraint: string
        if (!is_null($premium) && !is_string($premium)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($premium, true), gettype($premium)), __LINE__);
        }
        $this->premium = $premium;
        return $this;
    }
    /**
     * Get premiumRur value
     * @return string|null
     */
    public function getPremiumRur()
    {
        return $this->premiumRur;
    }
    /**
     * Set premiumRur value
     * @param string $premiumRur
     * @return \StructType\PolicyShortInfo
     */
    public function setPremiumRur($premiumRur = null)
    {
        // validation for constraint: string
        if (!is_null($premiumRur) && !is_string($premiumRur)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($premiumRur, true), gettype($premiumRur)), __LINE__);
        }
        $this->premiumRur = $premiumRur;
        return $this;
    }
    /**
     * Get state value
     * @return string|null
     */
    public function getState()
    {
        return $this->state;
    }
    /**
     * Set state value
     * @param string $state
     * @return \StructType\PolicyShortInfo
     */
    public function setState($state = null)
    {
        // validation for constraint: string
        if (!is_null($state) && !is_string($state)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($state, true), gettype($state)), __LINE__);
        }
        $this->state = $state;
        return $this;
    }
    /**
     * Get date value
     * @return string|null
     */
    public function getDate()
    {
        return $this->date;
    }
    /**
     * Set date value
     * @param string $date
     * @return \StructType\PolicyShortInfo
     */
    public function setDate($date = null)
    {
        // validation for constraint: string
        if (!is_null($date) && !is_string($date)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($date, true), gettype($date)), __LINE__);
        }
        $this->date = $date;
        return $this;
    }
    /**
     * Get dateBeg value
     * @return string|null
     */
    public function getDateBeg()
    {
        return $this->dateBeg;
    }
    /**
     * Set dateBeg value
     * @param string $dateBeg
     * @return \StructType\PolicyShortInfo
     */
    public function setDateBeg($dateBeg = null)
    {
        // validation for constraint: string
        if (!is_null($dateBeg) && !is_string($dateBeg)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($dateBeg, true), gettype($dateBeg)), __LINE__);
        }
        $this->dateBeg = $dateBeg;
        return $this;
    }
    /**
     * Get dateEnd value
     * @return string|null
     */
    public function getDateEnd()
    {
        return $this->dateEnd;
    }
    /**
     * Set dateEnd value
     * @param string $dateEnd
     * @return \StructType\PolicyShortInfo
     */
    public function setDateEnd($dateEnd = null)
    {
        // validation for constraint: string
        if (!is_null($dateEnd) && !is_string($dateEnd)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($dateEnd, true), gettype($dateEnd)), __LINE__);
        }
        $this->dateEnd = $dateEnd;
        return $this;
    }
}
