<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for PredstavitelListInfo StructType
 * @subpackage Structs
 */
class PredstavitelListInfo extends AbstractStructBase
{
    /**
     * The representatives
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * @var \StructType\IdentificRepresentativeInfo[]
     */
    public $representatives;
    /**
     * Constructor method for PredstavitelListInfo
     * @uses PredstavitelListInfo::setRepresentatives()
     * @param \StructType\IdentificRepresentativeInfo[] $representatives
     */
    public function __construct(array $representatives = array())
    {
        $this
            ->setRepresentatives($representatives);
    }
    /**
     * Get representatives value
     * @return \StructType\IdentificRepresentativeInfo[]|null
     */
    public function getRepresentatives()
    {
        return $this->representatives;
    }
    /**
     * This method is responsible for validating the values passed to the setRepresentatives method
     * This method is willingly generated in order to preserve the one-line inline validation within the setRepresentatives method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateRepresentativesForArrayConstraintsFromSetRepresentatives(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $predstavitelListInfoRepresentativesItem) {
            // validation for constraint: itemType
            if (!$predstavitelListInfoRepresentativesItem instanceof \StructType\IdentificRepresentativeInfo) {
                $invalidValues[] = is_object($predstavitelListInfoRepresentativesItem) ? get_class($predstavitelListInfoRepresentativesItem) : sprintf('%s(%s)', gettype($predstavitelListInfoRepresentativesItem), var_export($predstavitelListInfoRepresentativesItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The representatives property can only contain items of type \StructType\IdentificRepresentativeInfo, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set representatives value
     * @throws \InvalidArgumentException
     * @param \StructType\IdentificRepresentativeInfo[] $representatives
     * @return \StructType\PredstavitelListInfo
     */
    public function setRepresentatives(array $representatives = array())
    {
        // validation for constraint: array
        if ('' !== ($representativesArrayErrorMessage = self::validateRepresentativesForArrayConstraintsFromSetRepresentatives($representatives))) {
            throw new \InvalidArgumentException($representativesArrayErrorMessage, __LINE__);
        }
        $this->representatives = $representatives;
        return $this;
    }
    /**
     * Add item to representatives value
     * @throws \InvalidArgumentException
     * @param \StructType\IdentificRepresentativeInfo $item
     * @return \StructType\PredstavitelListInfo
     */
    public function addToRepresentatives(\StructType\IdentificRepresentativeInfo $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\IdentificRepresentativeInfo) {
            throw new \InvalidArgumentException(sprintf('The representatives property can only contain items of type \StructType\IdentificRepresentativeInfo, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->representatives[] = $item;
        return $this;
    }
}
