<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for RepresentativeInfo StructType
 * @subpackage Structs
 */
class RepresentativeInfo extends AbstractStructBase
{
    /**
     * The lastName
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $lastName;
    /**
     * The name
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $name;
    /**
     * The middleName
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $middleName;
    /**
     * The procuracyNumber
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $procuracyNumber;
    /**
     * The procuracyDate
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $procuracyDate;
    /**
     * Constructor method for RepresentativeInfo
     * @uses RepresentativeInfo::setLastName()
     * @uses RepresentativeInfo::setName()
     * @uses RepresentativeInfo::setMiddleName()
     * @uses RepresentativeInfo::setProcuracyNumber()
     * @uses RepresentativeInfo::setProcuracyDate()
     * @param string $lastName
     * @param string $name
     * @param string $middleName
     * @param string $procuracyNumber
     * @param string $procuracyDate
     */
    public function __construct($lastName = null, $name = null, $middleName = null, $procuracyNumber = null, $procuracyDate = null)
    {
        $this
            ->setLastName($lastName)
            ->setName($name)
            ->setMiddleName($middleName)
            ->setProcuracyNumber($procuracyNumber)
            ->setProcuracyDate($procuracyDate);
    }
    /**
     * Get lastName value
     * @return string|null
     */
    public function getLastName()
    {
        return $this->lastName;
    }
    /**
     * Set lastName value
     * @param string $lastName
     * @return \StructType\RepresentativeInfo
     */
    public function setLastName($lastName = null)
    {
        // validation for constraint: string
        if (!is_null($lastName) && !is_string($lastName)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($lastName, true), gettype($lastName)), __LINE__);
        }
        $this->lastName = $lastName;
        return $this;
    }
    /**
     * Get name value
     * @return string|null
     */
    public function getName()
    {
        return $this->name;
    }
    /**
     * Set name value
     * @param string $name
     * @return \StructType\RepresentativeInfo
     */
    public function setName($name = null)
    {
        // validation for constraint: string
        if (!is_null($name) && !is_string($name)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($name, true), gettype($name)), __LINE__);
        }
        $this->name = $name;
        return $this;
    }
    /**
     * Get middleName value
     * @return string|null
     */
    public function getMiddleName()
    {
        return $this->middleName;
    }
    /**
     * Set middleName value
     * @param string $middleName
     * @return \StructType\RepresentativeInfo
     */
    public function setMiddleName($middleName = null)
    {
        // validation for constraint: string
        if (!is_null($middleName) && !is_string($middleName)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($middleName, true), gettype($middleName)), __LINE__);
        }
        $this->middleName = $middleName;
        return $this;
    }
    /**
     * Get procuracyNumber value
     * @return string|null
     */
    public function getProcuracyNumber()
    {
        return $this->procuracyNumber;
    }
    /**
     * Set procuracyNumber value
     * @param string $procuracyNumber
     * @return \StructType\RepresentativeInfo
     */
    public function setProcuracyNumber($procuracyNumber = null)
    {
        // validation for constraint: string
        if (!is_null($procuracyNumber) && !is_string($procuracyNumber)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($procuracyNumber, true), gettype($procuracyNumber)), __LINE__);
        }
        $this->procuracyNumber = $procuracyNumber;
        return $this;
    }
    /**
     * Get procuracyDate value
     * @return string|null
     */
    public function getProcuracyDate()
    {
        return $this->procuracyDate;
    }
    /**
     * Set procuracyDate value
     * @param string $procuracyDate
     * @return \StructType\RepresentativeInfo
     */
    public function setProcuracyDate($procuracyDate = null)
    {
        // validation for constraint: string
        if (!is_null($procuracyDate) && !is_string($procuracyDate)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($procuracyDate, true), gettype($procuracyDate)), __LINE__);
        }
        $this->procuracyDate = $procuracyDate;
        return $this;
    }
}
