<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for SubjectChangesInfo StructType
 * @subpackage Structs
 */
class SubjectChangesInfo extends AbstractStructBase
{
    /**
     * The physical
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var \StructType\PhysicalSubjectChangesInfo
     */
    public $physical;
    /**
     * The juridical
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var \StructType\JuridicalSubjectChanges
     */
    public $juridical;
    /**
     * Constructor method for SubjectChangesInfo
     * @uses SubjectChangesInfo::setPhysical()
     * @uses SubjectChangesInfo::setJuridical()
     * @param \StructType\PhysicalSubjectChangesInfo $physical
     * @param \StructType\JuridicalSubjectChanges $juridical
     */
    public function __construct(\StructType\PhysicalSubjectChangesInfo $physical = null, \StructType\JuridicalSubjectChanges $juridical = null)
    {
        $this
            ->setPhysical($physical)
            ->setJuridical($juridical);
    }
    /**
     * Get physical value
     * @return \StructType\PhysicalSubjectChangesInfo|null
     */
    public function getPhysical()
    {
        return $this->physical;
    }
    /**
     * Set physical value
     * @param \StructType\PhysicalSubjectChangesInfo $physical
     * @return \StructType\SubjectChangesInfo
     */
    public function setPhysical(\StructType\PhysicalSubjectChangesInfo $physical = null)
    {
        $this->physical = $physical;
        return $this;
    }
    /**
     * Get juridical value
     * @return \StructType\JuridicalSubjectChanges|null
     */
    public function getJuridical()
    {
        return $this->juridical;
    }
    /**
     * Set juridical value
     * @param \StructType\JuridicalSubjectChanges $juridical
     * @return \StructType\SubjectChangesInfo
     */
    public function setJuridical(\StructType\JuridicalSubjectChanges $juridical = null)
    {
        $this->juridical = $juridical;
        return $this;
    }
}
